%global base_version 1.11.4

%global pom_version 1.11.4
%global mvn_settings -s mirror-settings.xml


%if %{?build_number:1}%{!?build_number:0}
%define package_version %{base_version}.build%{build_number}
%else
%define package_version %{base_version}
%endif


%define _modulename backend-server
%define prefixname storm


Name:    storm-backend-server
Version: %{package_version}
Release: 0%{?dist}
Summary: The StoRM backend server

Group: Applications/File
License:  ASL 2.0
Url: https://github.com/italiangrid/storm
Source:    %{name}.tar.gz
BuildRoot: %{_tmppath}/%{name}

BuildArch: noarch

BuildRequires: maven
BuildRequires: jpackage-utils
BuildRequires: java-1.6.0-openjdk-devel

Requires(post):   chkconfig
Requires(preun):  chkconfig
Requires(preun):  initscripts
Requires(postun): initscripts

Requires: java-1.6.0-openjdk
Requires: mysql
Requires: mysql-server
Requires: nc
Requires: xml-commons-apis
Requires: mysql-connector-java
Requires: jpackage-utils
Requires: storm-native-libs
Requires: storm-native-libs-lcmaps
Requires: storm-native-libs-java


%description
StoRM provides an SRM interface to any POSIX filesystem with direct file
access ("file:" transport protocol), but can take advantage of special
features of high performance parallel and cluster file systems, as GPFS from 
IBM and Lustre from SUN. 

This package contains the StoRM backend server.


%prep
%setup -q -n %{name}

%build
mvn -s mirror-settings.xml -DskipTests -U package

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
tar -C $RPM_BUILD_ROOT -xvzf target/%{name}.tar.gz

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(644,root,root,755)

%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar

%attr(755,root,root) %{_sysconfdir}/%{prefixname}/%{_modulename}/db/storm_database_config.sh
%{_sysconfdir}/%{prefixname}/%{_modulename}/db/storm_be_ISAM_mysql_update_from_1.0.0_to_1.1.0.sql
%{_sysconfdir}/%{prefixname}/%{_modulename}/db/storm_mysql_grant.sql
%{_sysconfdir}/%{prefixname}/%{_modulename}/db/storm_mysql_tbl.sql
%{_sysconfdir}/%{prefixname}/%{_modulename}/lcmaps.db
%config(noreplace) %{_sysconfdir}/%{prefixname}/%{_modulename}/logging.xml
%{_sysconfdir}/%{prefixname}/%{_modulename}/namespace-1.5.0.xsd
%config(noreplace) %{_sysconfdir}/%{prefixname}/%{_modulename}/namespace.xml
%config(noreplace) %{_sysconfdir}/%{prefixname}/%{_modulename}/path-authz.db
%{_sysconfdir}/%{prefixname}/%{_modulename}/storm.properties.template
%{_sysconfdir}/%{prefixname}/%{_modulename}/used-space.ini.template
%{_sysconfdir}/%{prefixname}/%{_modulename}/welcome.txt
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%attr(755,root,root) %{_sysconfdir}/init.d/%{name}

%dir %{_localstatedir}/log/%{prefixname}


%post
# when installing
if [ "$1" = "1" ] ; then
  # add the service to chk
  /sbin/chkconfig --add %{name}
  # create mysql-connector-java jar link
  /bin/ln -sf /usr/share/java/mysql-connector-java.jar %{_javadir}/%{name}/mysql-connector-java.jar
# when upgrading
elif [ $1 -gt 1 ] ; then
  # create mysql-connector-java jar link if it does not exist
  if [ ! -L %{_javadir}/%{name}/mysql-connector-java.jar ] ; then
    /bin/ln -sf /usr/share/java/mysql-connector-java.jar %{_javadir}/%{name}/mysql-connector-java.jar
  fi
  # remove old mysql-connector-java jar link
  if [ -L %{_javadir}/%{name}/mysql-connector-java-5.1.12.jar ] ; then
    /bin/unlink %{_javadir}/%{name}/mysql-connector-java-5.1.12.jar
  fi    
  # start the service
  /sbin/service %{name} restart >/dev/null 2>&1 || :
fi;

%preun
# when uninstalling
if [ "$1" = "0" ] ; then
  # stop the service
  /sbin/service %{name} stop >/dev/null 2>&1 || :
  # remove the service from chk
  /sbin/chkconfig --del %{name}
  # remove mysql-connector-java jar link
  /bin/unlink %{_javadir}/%{name}/mysql-connector-java.jar
fi;

%changelog
* Tue Jan 14 2014 Andrea Ceccanti <andrea.ceccanti at cnaf.infn.it> - 1.11.4-0
- Fix for https://issues.infn.it/jira/browse/STOR-501

* Wed Oct 30 2013 Andrea Ceccanti <andrea.ceccanti at cnaf.infn.it> - 1.11.3-1
- Fix for https://issues.infn.it/jira/browse/STOR-341
- Fix for https://issues.infn.it/jira/browse/STOR-342
- Fix for https://issues.infn.it/jira/browse/STOR-344

* Wed Jun 12 2013 Andrea Ceccanti <andrea.ceccanti at cnaf.infn.it> - 1.11.2-1
- Integrated native libs interface v. 1.0.1
